cascading.flow.stream.element

## Class GroupingSpliceGate

- java.lang.Object
- - cascading.flow.stream.duct.Duct<Incoming,Outgoing>
  - - cascading.flow.stream.duct.Gate<Incoming,Outgoing>
    - - cascading.flow.stream.element.SpliceGate<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>
      - - cascading.flow.stream.element.GroupingSpliceGate

- All Implemented Interfaces:
    Collapsing, Window, ElementDuct
  Direct Known Subclasses:
    HadoopGroupGate, MemorySpliceGate

      public abstract class GroupingSpliceGate
      extends SpliceGate<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>
      implements Window

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `GroupingSpliceGate.DelegatedTuple`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Comparator<Tuple>[]` | `groupComparators`
    `protected TupleHasher` | `groupHasher`
    `protected Grouping<TupleEntry,TupleEntryIterator>` | `grouping`
    `protected Resettable2<Tuple,Tuple>` | `groupSortTuple`
    `protected Resettable1<Tuple>` | `groupTuple`
    `protected TupleBuilder[]` | `keyBuilder`
    `protected TupleEntry` | `keyEntry`
    `protected Fields[]` | `keyFields`
    `protected Tuple` | `keyTuple`
    `protected boolean` | `nullsAreNotEqual`
    `protected Map<Duct,Integer>` | `ordinalMap`
    `protected TupleBuilder[]` | `sortBuilder`
    `protected Fields[]` | `sortFields`
    `protected TupleEntryChainIterator` | `tupleEntryIterator`
    `protected Comparator<Tuple>[]` | `valueComparators`
    `protected TupleBuilder[]` | `valuesBuilder`
    `protected Fields[]` | `valuesFields`
    `protected Resettable1<Tuple>` | `valueTuple`

    - ### Fields inherited from class cascading.flow.stream.element.SpliceGate

      `flowProcess, incomingScopes, outgoingScopes, role, splice`

    - ### Fields inherited from class cascading.flow.stream.duct.Duct

      `next, ordinal`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `GroupingSpliceGate(FlowProcess flowProcess, Splice splice)`
    `protected` | `GroupingSpliceGate(FlowProcess flowProcess, Splice splice, IORole role)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `bind(StreamGraph streamGraph)`
    `void` | `cleanup()`
    `protected TupleBuilder` | `createDefaultNarrowBuilder(Fields incomingFields, Fields narrowFields)`
    `protected TupleBuilder` | `createNarrowBuilder(Fields incomingFields, Fields narrowFields)`
    `protected TupleBuilder` | `createNulledBuilder(Fields incomingFields, Fields keyField)`
    `boolean` | `equals(Object object)`
    `protected Tuple` | `getDelegatedTuple(Tuple object)` This allows the tuple to honor the hasher and comparators, if any
    `protected Comparator` | `getKeyComparator()`
    `protected int` | `getNumDeclaredIncomingBranches()`
    `int` | `hashCode()`
    `protected void` | `initComparators()`
    `void` | `initialize()` Called immediately after bind
    `protected void` | `setOrdinalMap(StreamGraph streamGraph)`
    `String` | `toString()`

    - ### Methods inherited from class cascading.flow.stream.element.SpliceGate

      `getBranchNames, getFlowElement, getIncomingScopes, getOutgoingScopes, getSplice, handleException, handleReThrowableException, hasTrapHandler, setBranchNames, setTrapHandler`

    - ### Methods inherited from class cascading.flow.stream.duct.Duct

      `complete, getNext, getNextFor, prepare, receive, receiveFirst, start`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ordinalMap

          protected Map<Duct,Integer> ordinalMap

    - #### keyFields

          protected Fields[] keyFields

    - #### sortFields

          protected Fields[] sortFields

    - #### valuesFields

          protected Fields[] valuesFields

    - #### groupComparators

          protected Comparator<Tuple>[] groupComparators

    - #### valueComparators

          protected Comparator<Tuple>[] valueComparators

    - #### groupHasher

          protected TupleHasher groupHasher

    - #### nullsAreNotEqual

          protected boolean nullsAreNotEqual

    - #### keyBuilder

          protected TupleBuilder[] keyBuilder

    - #### valuesBuilder

          protected TupleBuilder[] valuesBuilder

    - #### sortBuilder

          protected TupleBuilder[] sortBuilder

    - #### keyTuple

          protected Tuple keyTuple

    - #### groupTuple

          protected Resettable1<Tuple> groupTuple

    - #### groupSortTuple

          protected Resettable2<Tuple,Tuple> groupSortTuple

    - #### valueTuple

          protected Resettable1<Tuple> valueTuple

    - #### grouping

          protected Grouping<TupleEntry,TupleEntryIterator> grouping

    - #### keyEntry

          protected TupleEntry keyEntry

    - #### tupleEntryIterator

          protected TupleEntryChainIterator tupleEntryIterator

  - ### Constructor Detail

    - #### GroupingSpliceGate

          protected GroupingSpliceGate(FlowProcess flowProcess,
                            Splice splice)

    - #### GroupingSpliceGate

          protected GroupingSpliceGate(FlowProcess flowProcess,
                            Splice splice,
                            IORole role)

  - ### Method Detail

    - #### bind

          public void bind(StreamGraph streamGraph)

      Overrides:
        `bind` in class `Duct<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>`

    - #### setOrdinalMap

          protected void setOrdinalMap(StreamGraph streamGraph)

    - #### createNarrowBuilder

          protected TupleBuilder createNarrowBuilder(Fields incomingFields,
                                         Fields narrowFields)

    - #### createDefaultNarrowBuilder

          protected TupleBuilder createDefaultNarrowBuilder(Fields incomingFields,
                                                Fields narrowFields)

    - #### createNulledBuilder

          protected TupleBuilder createNulledBuilder(Fields incomingFields,
                                         Fields keyField)

    - #### initialize

          public void initialize()

      Description copied from class: `Duct`
      Called immediately after bind
      Overrides:
        `initialize` in class `SpliceGate<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>`

    - #### initComparators

          protected void initComparators()

    - #### getKeyComparator

          protected Comparator getKeyComparator()

    - #### cleanup

          public void cleanup()

      Overrides:
        `cleanup` in class `Duct<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>`

    - #### getNumDeclaredIncomingBranches

          protected int getNumDeclaredIncomingBranches()

    - #### getDelegatedTuple

          protected final Tuple getDelegatedTuple(Tuple object)

      This allows the tuple to honor the hasher and comparators, if any
      Parameters:
        `object` - the tuple to wrap
      Returns:
        a DelegatedTuple instance

    - #### equals

          public final boolean equals(Object object)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public final int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Duct<TupleEntry,Grouping<TupleEntry,TupleEntryIterator>>`

Copyright © 2007-2015 Concurrent, Inc. All Rights Reserved.